/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.cpu.mode.*;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class SUB extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               SUB.class,
               "SUB",
               false,
               new ParamDecls(),
               new Shortcuts()
                   .addShortcut(new Info_alu_instr(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            return new SUB();
        }
    }

    private static final class Info_alu_instr extends InfoAndRule
    {
        Info_alu_instr()
        {
            super(
                alu_instr.class,
                "SUB",
                true,
                new ParamDecls()
                    .declareParam("op1", OPRNDL.INFO)
                    .declareParam("op2", OPRNDR.INFO)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode op1 = (IAddressingMode) getArgument("op1", args);
            final IAddressingMode op2 = (IAddressingMode) getArgument("op2", args);

            return new alu_instr(
                new SUB(),
                op1,
                op2
            );
        }
    }

    public static final IInfo INFO = new Info();

    public SUB()
    {
    }

    @Override
    public String syntax()
    {
        return "sub";
    }

    @Override
    public String image()
    {
        return "01";
    }

    @Override
    public void action()
    {
        DEST.access().store(DataEngine.execute(EOperatorID.MINUS, SRC1.access().load(), SRC2.access().load()));
    }
}
