/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.shared;

import ru.ispras.microtesk.model.api.type.TypeId;
import ru.ispras.microtesk.model.api.type.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.state.Status;
import ru.ispras.microtesk.model.api.state.Resetter;

public final class Shared
{
    private Shared() {}

    public static final int MEM_SIZE = (int)Math.pow(2, 8);
    public static final int REG_NUMBER = 16;

    public static final Type INDEX = Type.typeDef("INDEX", Type.CARD(8));
    public static final Type NIBBLE = Type.typeDef("NIBBLE", Type.CARD(4));
    public static final Type BYTE = Type.typeDef("BYTE", Type.INT(8));

    public static final Memory GPR = Memory.REG("GPR", BYTE, REG_NUMBER);
    public static final Memory PC = Memory.REG("PC", INDEX, 1);
    public static final Memory M = Memory.MEM("M", BYTE, MEM_SIZE);
    public static final Memory SRC1 = Memory.VAR("SRC1", BYTE, 1);
    public static final Memory SRC2 = Memory.VAR("SRC2", BYTE, 1);
    public static final Memory DEST = Memory.VAR("DEST", BYTE, 1);

    public static final Memory[] __REGISTERS = {GPR, PC};
    public static final Memory[] __MEMORY = {M};
    public static final Memory[] __VARIABLES = {SRC1, SRC2, DEST};
    public static final Label[] __LABELS = {};

    public static final Status __CTRL_TRANSFER = new Status("__CTRL_TRANSFER", 0);
    public static final Status[] __STATUSES = {__CTRL_TRANSFER};

    public static final Resetter __RESETTER = new Resetter(__VARIABLES, __STATUSES);
}
 