/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips;

import ru.ispras.microtesk.model.api.ProcessorModel;
import ru.ispras.microtesk.model.api.debug.MetaModelPrinter;
import ru.ispras.microtesk.model.api.debug.ModelStatePrinter;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.minimips.op.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class Model extends ProcessorModel
{
    public static final String NAME = "minimips";

    private static final IAddressingMode.IInfo[] __MODES = new IAddressingMode.IInfo[]
    {
        REG.INFO,
        COP0.INFO
    };

    private static final IOperation.IInfo[] __OPS = new IOperation.IInfo[]
    {
        add.INFO,
        addi.INFO,
        addu.INFO,
        addiu.INFO,
        andi.INFO,
        sub.INFO,
        subu.INFO,
        mult.INFO,
        multu.INFO,
        and.INFO,
        or.INFO,
        nor.INFO,
        xor.INFO,
        ori.INFO,
        xori.INFO,
        sll.INFO,
        sllv.INFO,
        sra.INFO,
        srav.INFO,
        srl.INFO,
        srlv.INFO,
        lw.INFO,
        lui.INFO,
        sw.INFO,
        mfhi.INFO,
        mflo.INFO,
        mthi.INFO,
        mtlo.INFO,
        swc0.INFO,
        lwc0.INFO,
        mfc0.INFO,
        mtc0.INFO,
        beq.INFO,
        bgez.INFO,
        bgezal.INFO,
        bgtz.INFO,
        blez.INFO,
        bltz.INFO,
        bltzal.INFO,
        bne.INFO,
        slt.INFO,
        slti.INFO,
        sltiu.INFO,
        sltu.INFO,
        j.INFO,
        jr.INFO,
        jal.INFO,
        jalr.INFO,
        syscall.INFO,
        cop0.INFO,
        mips_break.INFO,
        instruction.INFO,
        la.INFO
    };

    public Model()
    {
        super(
            NAME,
            __MODES,
            __OPS,
            __REGISTERS,
            __MEMORY,
            __LABELS,
            __STATUSES,
            __RESETTER
            );
    }

    public static void printInformation()
    {
        final Model model = new Model();

        final MetaModelPrinter metaModelPrinter = new MetaModelPrinter(model.getMetaData());
        metaModelPrinter.printAll();

        final ModelStatePrinter modelStatePrinter = new ModelStatePrinter(model);
        modelStatePrinter.printRegisters();
    }

    public static void main(String[] args)
    {
        printInformation();
    }
}
 