/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class beq extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               beq.class,
               "beq",
               false,
               new ParamDecls()
                   .declareParam("rs", REG.INFO)
                   .declareParam("rt", REG.INFO)
                   .declareParam("imm", SHORT),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final Location imm = (Location) getArgument("imm", args);

            return new beq(rs, rt, imm);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "beq",
                true,
                new ParamDecls()
                    .declareParam("rs", REG.INFO)
                    .declareParam("rt", REG.INFO)
                    .declareParam("imm", SHORT)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final Location imm = (Location) getArgument("imm", args);

            return new instruction(
                new beq(
                    rs,
                    rt,
                    imm
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rs;
    private final IAddressingMode rt;
    private final Location imm;

    public beq(IAddressingMode rs, IAddressingMode rt, Location imm)
    {
        assert REG.INFO.isSupported(rs);
        assert REG.INFO.isSupported(rt);
        assert SHORT.equals(imm.getType());

        this.rs = rs;
        this.rt = rt;
        this.imm = imm;
    }

    @Override
    public String syntax()
    {
        return String.format("beq %s, %s, <label>%d", rs.syntax(), rt.syntax(), imm.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("000100%s%s%s", rs.image(), rt.image(), imm.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.EQ, rs.access().load(), rt.access().load())))
        {
            BRANCH.access().store(DataEngine.valueOf(Type.INT(1), 1));
            JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.coerce(WORD, DataEngine.execute(EOperatorID.MUL, DataEngine.valueOf(SHORT, 4), imm.load()))), DataEngine.valueOf(WORD, 4)));
        }
    }
}
