/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class jal extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               jal.class,
               "jal",
               false,
               new ParamDecls()
                   .declareParam("addr", JUMP_IMM),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final Location addr = (Location) getArgument("addr", args);

            return new jal(addr);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "jal",
                true,
                new ParamDecls()
                    .declareParam("addr", JUMP_IMM)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final Location addr = (Location) getArgument("addr", args);

            return new instruction(
                new jal(
                    addr
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final Location addr;

    public jal(Location addr)
    {
        assert JUMP_IMM.equals(addr.getType());

        this.addr = addr;
    }

    @Override
    public String syntax()
    {
        return String.format("jal <label>%d", addr.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("000011%s", addr.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        GPR.access(31).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 4)), DataEngine.valueOf(WORD, 4)));
        cia_copy.access().store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 4)));
        temp_jump.access().store(DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(Type.CARD(28), addr.load()), DataEngine.valueOf(Type.CARD(28), 2)));
        BRANCH.access().store(DataEngine.valueOf(Type.INT(1), 1));
        JMPADDR.access().store(Location.concat(temp_jump.access(), CIA.access().bitField(31, 28)).load());
    }
}
