/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class lui extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               lui.class,
               "lui",
               false,
               new ParamDecls()
                   .declareParam("rt", REG.INFO)
                   .declareParam("imm", SHORT),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final Location imm = (Location) getArgument("imm", args);

            return new lui(rt, imm);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "lui",
                true,
                new ParamDecls()
                    .declareParam("rt", REG.INFO)
                    .declareParam("imm", SHORT)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final Location imm = (Location) getArgument("imm", args);

            return new instruction(
                new lui(
                    rt,
                    imm
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rt;
    private final Location imm;

    public lui(IAddressingMode rt, Location imm)
    {
        assert REG.INFO.isSupported(rt);
        assert SHORT.equals(imm.getType());

        this.rt = rt;
        this.imm = imm;
    }

    @Override
    public String syntax()
    {
        return String.format("lui %s, %d", rt.syntax(), imm.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("001111%s%s", rt.image(), imm.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        rt.access().store(DataEngine.execute(EOperatorID.L_SHIFT, DataEngine.coerce(WORD, imm.load()), DataEngine.valueOf(WORD, 8)));
    }
}
