/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class mfhi extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               mfhi.class,
               "mfhi",
               false,
               new ParamDecls()
                   .declareParam("rd", REG.INFO),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);

            return new mfhi(rd);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "mfhi",
                true,
                new ParamDecls()
                    .declareParam("rd", REG.INFO)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);

            return new instruction(
                new mfhi(
                    rd
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rd;

    public mfhi(IAddressingMode rd)
    {
        assert REG.INFO.isSupported(rd);

        this.rd = rd;
    }

    @Override
    public String syntax()
    {
        return String.format("mfhi %s", rd.syntax());
    }

    @Override
    public String image()
    {
        return String.format("0000000000000000%s00000010000", rd.image());
    }

    @Override
    public void action()
    {
        rd.access().store(HI.access(0).load());
    }
}
