/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class srav extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               srav.class,
               "srav",
               false,
               new ParamDecls()
                   .declareParam("rd", REG.INFO)
                   .declareParam("rt", REG.INFO)
                   .declareParam("rs", REG.INFO),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);

            return new srav(rd, rt, rs);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "srav",
                true,
                new ParamDecls()
                    .declareParam("rd", REG.INFO)
                    .declareParam("rt", REG.INFO)
                    .declareParam("rs", REG.INFO)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
            final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);

            return new instruction(
                new srav(
                    rd,
                    rt,
                    rs
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode rd;
    private final IAddressingMode rt;
    private final IAddressingMode rs;

    public srav(IAddressingMode rd, IAddressingMode rt, IAddressingMode rs)
    {
        assert REG.INFO.isSupported(rd);
        assert REG.INFO.isSupported(rt);
        assert REG.INFO.isSupported(rs);

        this.rd = rd;
        this.rt = rt;
        this.rs = rs;
    }

    @Override
    public String syntax()
    {
        return String.format("srav %s, %s, %s", rd.syntax(), rt.syntax(), rs.syntax());
    }

    @Override
    public String image()
    {
        return String.format("00000000000%s%s%s000111", rt.image(), rd.image(), rs.image());
    }

    @Override
    public void action()
    {
        rd.access().store(DataEngine.execute(EOperatorID.R_SHIFT, rt.access().load(), DataEngine.coerce(WORD, rs.access().bitField(4, 0).load())));
    }
}
