/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class swc0 extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               swc0.class,
               "swc0",
               false,
               new ParamDecls()
                   .declareParam("cs", COP0.INFO)
                   .declareParam("offset", SHORT)
                   .declareParam("address", REG.INFO),
               new Shortcuts()
                   .addShortcut(new Info_instruction(), "#root")
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode cs = (IAddressingMode) getArgument("cs", args);
            final Location offset = (Location) getArgument("offset", args);
            final IAddressingMode address = (IAddressingMode) getArgument("address", args);

            return new swc0(cs, offset, address);
        }
    }

    private static final class Info_instruction extends InfoAndRule
    {
        Info_instruction()
        {
            super(
                instruction.class,
                "swc0",
                true,
                new ParamDecls()
                    .declareParam("cs", COP0.INFO)
                    .declareParam("offset", SHORT)
                    .declareParam("address", REG.INFO)
            );
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode cs = (IAddressingMode) getArgument("cs", args);
            final Location offset = (Location) getArgument("offset", args);
            final IAddressingMode address = (IAddressingMode) getArgument("address", args);

            return new instruction(
                new swc0(
                    cs,
                    offset,
                    address
                )
            );
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode cs;
    private final Location offset;
    private final IAddressingMode address;

    public swc0(IAddressingMode cs, Location offset, IAddressingMode address)
    {
        assert COP0.INFO.isSupported(cs);
        assert SHORT.equals(offset.getType());
        assert REG.INFO.isSupported(address);

        this.cs = cs;
        this.offset = offset;
        this.address = address;
    }

    @Override
    public String syntax()
    {
        return String.format("swc0 %s, %d(%s)", cs.syntax(), offset.load().getRawData().intValue(), address.syntax());
    }

    @Override
    public String image()
    {
        return String.format("111000%s%s%s", address.image(), cs.image(), offset.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        M.access(DataEngine.intValue(DataEngine.execute(EOperatorID.PLUS, address.access().load(), DataEngine.coerce(WORD, offset.load()))) >> 2).store(cs.access().load());
    }
}
