/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.shared;

import ru.ispras.microtesk.model.api.type.TypeId;
import ru.ispras.microtesk.model.api.type.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;
import ru.ispras.microtesk.model.api.state.Status;
import ru.ispras.microtesk.model.api.state.Resetter;

public final class Shared
{
    private Shared() {}

    public static final String PC = "CIA";

    public static final int REGISTER_INDEX_SIZE = 5;

    public static final Type BYTE = Type.typeDef("BYTE", Type.CARD(8));
    public static final Type WORD = Type.typeDef("WORD", Type.INT(32));
    public static final Type SHORT = Type.typeDef("SHORT", Type.INT(16));
    public static final Type INDEX = Type.typeDef("INDEX", Type.CARD(5));
    public static final Type BIT = Type.typeDef("BIT", Type.CARD(1));
    public static final Type JUMP_IMM = Type.typeDef("JUMP_IMM", Type.CARD(26));

    public static final Memory GPR = Memory.REG("GPR", WORD, 32);
    public static final Memory COP0_R = Memory.REG("COP0_R", WORD, 32);
    public static final Memory HI = Memory.REG("HI", WORD, 1);
    public static final Memory LO = Memory.REG("LO", WORD, 1);
    public static final Memory M = Memory.MEM("M", WORD, (int)Math.pow(2, 16));
    public static final Memory CIA = Memory.REG("CIA", WORD, 1);
    public static final Memory JMPADDR = Memory.MEM("JMPADDR", WORD, 1);
    public static final Memory BRANCH = Memory.MEM("BRANCH", BIT, 1);
    public static final Memory temp = Memory.VAR("temp", Type.INT(33), 1);
    public static final Memory temp_jump = Memory.VAR("temp_jump", Type.CARD(28), 1);
    public static final Memory mult_result = Memory.VAR("mult_result", Type.INT(64), 1);
    public static final Memory mult_result_unsigned = Memory.VAR("mult_result_unsigned", Type.CARD(64), 1);
    public static final Memory cia_copy = Memory.VAR("cia_copy", WORD, 1);

    public static final Memory[] __REGISTERS = {GPR, COP0_R, HI, LO, CIA};
    public static final Memory[] __MEMORY = {M, JMPADDR, BRANCH};
    public static final Memory[] __VARIABLES = {temp, temp_jump, mult_result, mult_result_unsigned, cia_copy};
    public static final Label[] __LABELS = {new Label("PC", CIA, 0)};

    public static final Status __CTRL_TRANSFER = new Status("__CTRL_TRANSFER", 0);
    public static final Status[] __STATUSES = {__CTRL_TRANSFER};

    public static final Resetter __RESETTER = new Resetter(__VARIABLES, __STATUSES);
}
 