/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class BFT extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               BFT.class,
               "BFT",
               false,
               new ParamDecls()
                   .declareParam("cc", COND_CODE)
                   .declareParam("offset", SHORT));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final Location cc = (Location) getArgument("cc", args);
            final Location offset = (Location) getArgument("offset", args);

            return new BFT(cc, offset);
        }
    }

    public static final IInfo INFO = new Info();

    private final Location cc;
    private final Location offset;

    public BFT(Location cc, Location offset)
    {
        assert COND_CODE.equals(cc.getType());
        assert SHORT.equals(offset.getType());

        this.cc = cc;
        this.offset = offset;
    }

    @Override
    public String syntax()
    {
        return String.format("BFT %d, <label>%d", cc.load().getRawData().intValue(), offset.load().getRawData().intValue());
    }

    @Override
    public String image()
    {
        return String.format("01000101000%s01%s", cc.load().getRawData().toString(), offset.load().getRawData().toString());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(FCCR.access().bitField(DataEngine.intValue(cc.load()), DataEngine.intValue(cc.load())).load()) == 1)
        {
            BRANCH.access().store(DataEngine.valueOf(Type.INT(1), 1));
            JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.coerce(Type.INT(32), NIA.access().load()), DataEngine.coerce(Type.INT(32), DataEngine.execute(EOperatorID.L_SHIFT, offset.load(), DataEngine.valueOf(SHORT, 3)))));
        }
    }
}
