/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVN_S extends Operation
{
    private static final class Info extends InfoAndRule
    {
        Info()
        {
            super(
               MOVN_S.class,
               "MOVN_S",
               false,
               new ParamDecls()
                   .declareParam("fd", F.INFO)
                   .declareParam("fs", F.INFO)
                   .declareParam("rt", R.INFO));
        }

        @Override
        public IOperation create(Map<String, Object> args)
        {
            final IAddressingMode fd = (IAddressingMode) getArgument("fd", args);
            final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);
            final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

            return new MOVN_S(fd, fs, rt);
        }
    }

    public static final IInfo INFO = new Info();

    private final IAddressingMode fd;
    private final IAddressingMode fs;
    private final IAddressingMode rt;

    public MOVN_S(IAddressingMode fd, IAddressingMode fs, IAddressingMode rt)
    {
        assert F.INFO.isSupported(fd);
        assert F.INFO.isSupported(fs);
        assert R.INFO.isSupported(rt);

        this.fd = fd;
        this.fs = fs;
        this.rt = rt;
    }

    @Override
    public String syntax()
    {
        return String.format("MOVN_S %s, %s, %s", fd.syntax(), fs.syntax(), rt.syntax());
    }

    @Override
    public String image()
    {
        return String.format("01000110000%s%s%s010011", rt.image(), fs.image(), fd.image());
    }

    @Override
    public void action()
    {
        if (DataEngine.intValue(rt.access().load()) != 0)
        {
            fd.access().store(fs.access().load());
        }
    }
}
